'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _carbonComponentsReact = require('carbon-components-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var leading0 = function leading0(num) {
  return num < 10 ? '0' + num : num;
};

var Countdown = function (_Component) {
  (0, _inherits3.default)(Countdown, _Component);

  function Countdown() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Countdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Countdown.__proto__ || (0, _getPrototypeOf2.default)(Countdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      days: 0,
      hours: 0,
      minutes: 0,
      seconds: 0
    }, _this.updateTimeUntil = function (deadline) {
      var time = deadline - new Date();

      if (time < 0) {
        _this.setState({ days: 0, hours: 0, minutes: 0, seconds: 0 });
      } else {
        var _seconds = Math.floor(time / 1000 % 60);
        var _minutes = Math.floor(time / 1000 / 60 % 60);
        var _hours = Math.floor(time / (1000 * 60 * 60) % 24);
        var _days = Math.floor(time / (1000 * 60 * 60 * 24));
        _this.setState({ days: _days, hours: _hours, minutes: _minutes, seconds: _seconds });
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Countdown, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.updateTimeUntil(this.props.deadline);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setInterval(function () {
        if (!_this2.props.isPaused) {
          _this2.updateTimeUntil(_this2.props.deadline);
        }
      }, 1000);
    }
  }, {
    key: 'getButton',
    value: function getButton() {
      return this.props.buttonTitle ? _react2.default.createElement(
        _carbonComponentsReact.Button,
        {
          kind: 'secondary',
          onClick: this.props.handleButtonClick
        },
        _react2.default.createElement(
          'div',
          { style: { display: 'flex', alignItems: 'center' } },
          this.props.buttonTitle,
          '\xA0',
          this.props.pausable ? this.props.isPaused ? _react2.default.createElement(_carbonComponentsReact.Icon, { name: 'icon--play--outline', fill: '#252D6B', width: '16', height: '16' }) : _react2.default.createElement(_carbonComponentsReact.Icon, { name: 'icon--pause--outline', fill: '#252D6B', width: '16', height: '16' }) : ''
        )
      ) : '';
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'pui-countdown' + (this.props.small ? ' pui-countdown-small' : '') },
        _react2.default.createElement(
          'div',
          { className: 'pui-countdown-top-bar' + (this.props.isPaused ? ' pui-paused' : '') },
          this.props.title
        ),
        _react2.default.createElement(
          'div',
          { className: 'pui-countdown-content' + (this.props.isPaused ? ' pui-paused' : '') },
          !this.props.small ? _react2.default.createElement(
            'div',
            { className: 'pui-countdown-days' },
            _react2.default.createElement(
              'div',
              { className: 'pui-countdown-number-column pui-countdown-number' },
              _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  leading0(this.state.days)
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'pui-countdown-number-column pui-countdown-number-text' },
              _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  'DAYS'
                )
              )
            )
          ) : '',
          _react2.default.createElement(
            'div',
            { className: 'pui-countdown-time' },
            _react2.default.createElement(
              'div',
              { className: 'pui-countdown-number-column pui-countdown-number' },
              !this.props.small ? _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-hours' },
                  leading0(this.state.hours)
                )
              ) : _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-hours' },
                  leading0(this.state.days)
                )
              ),
              !this.props.small ? _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-minutes' },
                  leading0(this.state.minutes)
                )
              ) : _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-minutes' },
                  leading0(this.state.hours)
                )
              ),
              !this.props.small ? _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-seconds' },
                  leading0(this.state.seconds)
                )
              ) : _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'pui-countdown-seconds' },
                  leading0(this.state.minutes)
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'pui-countdown-number-column pui-countdown-number-text' },
              this.props.small ? _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  'DAYS'
                )
              ) : '',
              _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  'HOURS'
                )
              ),
              _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  'MINUTES'
                )
              ),
              !this.props.small ? _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  null,
                  'SECONDS'
                )
              ) : ''
            )
          )
        ),
        this.getButton()
      );
    }
  }]);
  return Countdown;
}(_react.Component);

exports.default = Countdown;