'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactDocumentTitle = require('react-document-title');

var _reactDocumentTitle2 = _interopRequireDefault(_reactDocumentTitle);

var _carbonComponentsReact = require('carbon-components-react');

var _polymathAuth = require('polymath-auth');

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    error: state.network.error
  };
};

var MetamaskPage = function (_Component) {
  (0, _inherits3.default)(MetamaskPage, _Component);

  function MetamaskPage() {
    (0, _classCallCheck3.default)(this, MetamaskPage);
    return (0, _possibleConstructorReturn3.default)(this, (MetamaskPage.__proto__ || (0, _getPrototypeOf2.default)(MetamaskPage)).apply(this, arguments));
  }

  (0, _createClass3.default)(MetamaskPage, [{
    key: 'render',
    value: function render() {
      var h1 = void 0;
      var h3 = void 0;
      var link = _react2.default.createElement(
        'a',
        { href: 'https://metamask.io/', target: '_blank', rel: 'noopener noreferrer' },
        'https://metamask.io/'
      );
      switch (Number(this.props.error)) {
        case _polymathAuth.ERROR_LOCKED:
          h1 = 'Your MetaMask Is Locked';
          h3 = 'Simply open MetaMask and follow the instructions to unlock it.';
          break;

        case _polymathAuth.ERROR_NETWORK:
          h1 = 'Wrong Network';
          h3 = _react2.default.createElement(
            'span',
            null,
            'Network that you chose is not supported.',
            _react2.default.createElement('br', null),
            'Open MetaMask and choose ',
            this.props.networks,
            '.'
          );
          break;

        case _polymathAuth.ERROR_DISCONNECTED:
          h1 = 'Aw, Snap!';
          h3 = _react2.default.createElement(
            'span',
            null,
            'You were disconnected from the node for some reason. Please refresh the page.'
          );
          break;

        default:
          h1 = 'You Need MetaMask';
          h3 = _react2.default.createElement(
            'span',
            null,
            'MetaMask is a browser extension that links the operations performed on this dashboard with the blockchain. Please visit ',
            link,
            ' and install the MetaMask extension to your browser of choice.'
          );
      }
      return _react2.default.createElement(
        _reactDocumentTitle2.default,
        { title: 'Polymath' },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement('img', { src: _.logo, alt: 'Logo', className: 'pui-metamask-logo' }),
          _react2.default.createElement(
            'div',
            { className: 'pui-single-box' },
            _react2.default.createElement(
              'div',
              { className: 'pui-single-box-header' },
              _react2.default.createElement(
                'div',
                { className: 'pui-single-box-metamask' },
                _react2.default.createElement('img', { src: _.metamask, alt: 'Metamask' })
              ),
              _react2.default.createElement(
                'h1',
                { className: 'pui-h1' },
                h1
              ),
              _react2.default.createElement(
                'h3',
                { className: 'pui-h3' },
                h3
              )
            ),
            _react2.default.createElement(
              _carbonComponentsReact.Accordion,
              { className: 'pui-metamask-accordion' },
              _react2.default.createElement(
                _carbonComponentsReact.AccordionItem,
                { title: 'What software do you need to issue your Security Token?' },
                _react2.default.createElement(
                  'p',
                  null,
                  'To issue your Security Token, you need to have MetaMask installed in your browser.',
                  _react2.default.createElement('br', null),
                  'Additionally, in a wallet in your MetaMask account you need to have ETH and POLY.'
                )
              ),
              _react2.default.createElement(
                _carbonComponentsReact.AccordionItem,
                { title: 'Why is MetaMask locked?' },
                _react2.default.createElement(
                  'p',
                  null,
                  'MetaMask periodically locks itself for security reasons.',
                  _react2.default.createElement('br', null),
                  'Please open the MetaMask extension in your browser and enter your password to unlock MetaMask.'
                )
              )
            )
          )
        )
      );
    }
  }]);
  return MetamaskPage;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(mapStateToProps)(MetamaskPage);