'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactRouterDom = require('react-router-dom');

var _NoticeBar = require('../modules/notice/NoticeBar');

var _NoticeBar2 = _interopRequireDefault(_NoticeBar);

var _helpers = require('../helpers');

var _logo = require('../../img/logo.svg');

var _logo2 = _interopRequireDefault(_logo);

var _network = require('../../img/icons/network.svg');

var _network2 = _interopRequireDefault(_network);

var _poly = require('../../img/icons/poly.svg');

var _poly2 = _interopRequireDefault(_poly);

var _account = require('../../img/icons/account.svg');

var _account2 = _interopRequireDefault(_account);

var _token = require('../../img/icons/token.svg');

var _token2 = _interopRequireDefault(_token);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    network: state.network.name,
    account: state.network.account,
    balance: state.pui.account.balance,
    isNotice: state.pui.notice.isOpen
  };
};

var Navbar = function (_Component) {
  (0, _inherits3.default)(Navbar, _Component);

  function Navbar() {
    (0, _classCallCheck3.default)(this, Navbar);
    return (0, _possibleConstructorReturn3.default)(this, (Navbar.__proto__ || (0, _getPrototypeOf2.default)(Navbar)).apply(this, arguments));
  }

  (0, _createClass3.default)(Navbar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          balance = _props.balance,
          account = _props.account,
          network = _props.network,
          ticker = _props.ticker,
          logo = _props.logo,
          isNotice = _props.isNotice;

      return _react2.default.createElement(
        'div',
        { className: 'pui-navbar' + (isNotice ? ' pui-navbar-notice' : '') },
        _react2.default.createElement(_NoticeBar2.default, null),
        _react2.default.createElement(
          _reactRouterDom.Link,
          { to: '/' },
          _react2.default.createElement(
            'div',
            { className: 'pui-navbar-logo' },
            logo ? _react2.default.createElement('img', { src: logo, alt: 'Company Logo' }) : _react2.default.createElement('img', { src: _logo2.default, alt: 'Polymath' })
          )
        ),
        _react2.default.createElement(
          'ul',
          { className: 'pui-navbar-menu' },
          _react2.default.createElement(
            'li',
            null,
            _react2.default.createElement('img', {
              src: _network2.default,
              alt: 'Active network',
              style: { marginRight: '2px' }
            }),
            network
          ),
          _react2.default.createElement(
            'li',
            null,
            _react2.default.createElement('img', { src: _poly2.default, alt: 'Your POLY balance' }),
            balance ? (0, _helpers.thousandsDelimiter)(new _bignumber2.default(balance).integerValue()) + ' POLY' : '...'
          ),
          _react2.default.createElement(
            'li',
            null,
            _react2.default.createElement('img', { src: _account2.default, alt: 'Account' }),
            (0, _helpers.addressShortifier)(account)
          ),
          ticker ? _react2.default.createElement(
            'li',
            null,
            _react2.default.createElement('img', { src: _token2.default, alt: 'Token' }),
            ticker
          ) : ''
        )
      );
    }
  }]);
  return Navbar;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(mapStateToProps)(Navbar);