'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMeasure = require('react-measure');

var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO @bshevchenko: extract following styles into the scss file
var backgroundColor = '#F0F3F6';
var strokeColor = '#3D70B2';
var strokeWidth = 16;

var ProgressBar = function (_Component) {
  (0, _inherits3.default)(ProgressBar, _Component);

  function ProgressBar() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ProgressBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ProgressBar.__proto__ || (0, _getPrototypeOf2.default)(ProgressBar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      width: 0
    }, _this.handleResize = function (contentRect) {
      _this.setState({ width: contentRect.bounds.width });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          progress = _props.progress,
          style = _props.style;

      var width = this.state.width;

      // noinspection SpellCheckingInspection
      var pathStyle = {
        strokeDasharray: width + ' ' + width,
        // Draw a stroke from the beginning (the center of the rounded circle on
        // the left, strokeWidth/2 from the left edge) to the end (the center of
        // the rounded circle on the right, strokeWidth/2 from the right edge).
        strokeDashoffset: width * (1.0 - progress) + progress * strokeWidth + 'px'
        // Can put transitions on the stroke-dashoffset property for neat effects.
      };

      var halfWidth = strokeWidth / 2;
      var rightEnd = width - strokeWidth / 2;
      var pathString = 'M ' + halfWidth + ',' + halfWidth + '\n       L ' + rightEnd + ',' + halfWidth;
      var viewBox = '0 0 ' + width + ' ' + strokeWidth;

      return _react2.default.createElement(
        _reactMeasure2.default,
        {
          bounds: true,
          onResize: this.handleResize
        },
        function (_ref2) {
          var measureRef = _ref2.measureRef;
          return _react2.default.createElement(
            'div',
            { ref: measureRef },
            _react2.default.createElement(
              'svg',
              {
                className: 'pui-progress-bar ' + className,
                style: style,
                viewBox: viewBox
              },
              _react2.default.createElement('path', {
                className: 'pui-progress-bar-trail',
                d: pathString,
                strokeLinecap: 'round',
                stroke: backgroundColor,
                strokeWidth: strokeWidth,
                fillOpacity: '0'
              }),
              _react2.default.createElement('path', {
                className: 'pui-progress-bar-path',
                d: pathString,
                strokeLinecap: 'round',
                stroke: strokeColor,
                strokeWidth: strokeWidth,
                fillOpacity: '0',
                style: pathStyle
              })
            )
          );
        }
      );
    }
  }]);
  return ProgressBar;
}(_react.Component);

ProgressBar.defaultProps = {
  className: '',
  progress: 0,
  style: {}
};
exports.default = ProgressBar;