'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helpers = require('../helpers');

var _Countdown = require('./Countdown');

var _Countdown2 = _interopRequireDefault(_Countdown);

var _ProgressBar = require('./ProgressBar');

var _ProgressBar2 = _interopRequireDefault(_ProgressBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var niceAmount = function niceAmount(poly) {
  return poly.round(2).toNumber().toLocaleString();
};

var dateFormat = function dateFormat(date) {
  return date.toLocaleDateString('en', {
    year: 'numeric',
    month: 'long',
    day: 'numeric'
  });
};

var getCountdownProps = function getCountdownProps(startDate, endDate, isStoPaused) {
  var now = new Date();
  if (now < startDate) {
    return {
      deadline: startDate,
      title: 'Time Left Until the Offering Starts',
      isPaused: isStoPaused
    };
  } else if (now < endDate) {
    return {
      deadline: endDate,
      title: 'Time Left Until the Offering Ends',
      isPaused: isStoPaused
    };
  }
  return null;
};

var STOStatus = function (_Component) {
  (0, _inherits3.default)(STOStatus, _Component);

  function STOStatus() {
    (0, _classCallCheck3.default)(this, STOStatus);
    return (0, _possibleConstructorReturn3.default)(this, (STOStatus.__proto__ || (0, _getPrototypeOf2.default)(STOStatus)).apply(this, arguments));
  }

  (0, _createClass3.default)(STOStatus, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          token = _props.token,
          details = _props.details,
          notPausable = _props.notPausable;


      var countdownProps = getCountdownProps(details.start, details.end, this.props.isStoPaused);

      var symbol = details.isPolyFundraise ? 'POLY' : 'ETH';

      var raisedText = niceAmount(details.raised) + ' ' + symbol;
      var capText = niceAmount(details.cap) + ' ' + token.ticker;

      var distTokens = niceAmount(details.raised.times(details.rate));

      var fractionComplete = details.raised.div(details.cap.div(details.rate)).times(100).toFixed(1);

      return _react2.default.createElement(
        'div',
        { className: 'pui-page-box' },
        _react2.default.createElement(
          'h2',
          { className: 'pui-h2' },
          'Capped STO'
        ),
        _react2.default.createElement(
          'p',
          { className: 'pui-sto-status-contract' },
          'Contract ',
          (0, _helpers.etherscanAddress)(details.address)
        ),
        _react2.default.createElement(
          'div',
          { className: 'pui-sto-status-grow' + (this.props.isStoPaused ? ' pui-paused' : '') },
          _react2.default.createElement(
            'div',
            { className: 'pui-sto-status-numbers' },
            _react2.default.createElement(
              'div',
              null,
              fractionComplete,
              '%'
            ),
            _react2.default.createElement(
              'div',
              { className: 'pui-key-value' },
              _react2.default.createElement(
                'div',
                null,
                'Cap'
              ),
              capText
            )
          ),
          _react2.default.createElement(_ProgressBar2.default, {
            className: 'pui-sto-status-progress-bar',
            progress: fractionComplete / 100
          }),
          _react2.default.createElement(
            'div',
            { className: 'pui-sto-status-bottom-row' },
            _react2.default.createElement(
              'div',
              { className: 'pui-sto-status-dates' },
              _react2.default.createElement(
                'div',
                { className: 'pui-key-value' },
                _react2.default.createElement(
                  'div',
                  null,
                  'Start Date'
                ),
                dateFormat(details.start)
              ),
              _react2.default.createElement(
                'div',
                { className: 'pui-key-value' },
                _react2.default.createElement(
                  'div',
                  null,
                  'End Date'
                ),
                dateFormat(details.end)
              ),
              _react2.default.createElement(
                'div',
                { className: 'pui-key-value' },
                _react2.default.createElement(
                  'div',
                  null,
                  '1 ',
                  symbol,
                  ' ',
                  _react2.default.createElement(
                    'span',
                    null,
                    '= ',
                    details.rate,
                    ' ',
                    token.ticker
                  )
                )
              )
            ),
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                'div',
                { className: 'pui-key-value pui-countdown-raised' },
                _react2.default.createElement(
                  'div',
                  null,
                  'Total Funds Raised'
                ),
                raisedText,
                _react2.default.createElement(
                  'div',
                  null,
                  distTokens,
                  ' ',
                  token.ticker
                )
              )
            )
          )
        ),
        countdownProps != null && _react2.default.createElement(
          'div',
          { className: 'pui-countdown-container' },
          _react2.default.createElement(_Countdown2.default, {
            deadline: countdownProps.deadline,
            title: countdownProps.title,
            buttonTitle: notPausable ? undefined : this.props.isStoPaused ? 'RESUME STO' : 'PAUSE STO',
            handleButtonClick: this.props.toggleStoPause,
            isPaused: this.props.isStoPaused,
            pausable: !notPausable
          })
        ),
        _react2.default.createElement('div', { className: 'pui-clearfix' })
      );
    }
  }]);
  return STOStatus;
}(_react.Component);

exports.default = STOStatus;