'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _carbonComponentsReact = require('carbon-components-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var doNothing = function doNothing() {};

exports.default = function (_ref) {
  var _ref$input = _ref.input,
      name = _ref$input.name,
      onChange = _ref$input.onChange,
      onBlur = _ref$input.onBlur,
      label = _ref.label,
      _ref$meta = _ref.meta,
      touched = _ref$meta.touched,
      error = _ref$meta.error,
      className = _ref.className,
      placeholder = _ref.placeholder,
      rest = (0, _objectWithoutProperties3.default)(_ref, ['input', 'label', 'meta', 'className', 'placeholder']);

  var _name$split = name.split('-'),
      _name$split2 = (0, _slicedToArray3.default)(_name$split, 2),
      idStart = _name$split2[0],
      idEnd = _name$split2[1];

  var _label$split = label.split(';'),
      _label$split2 = (0, _slicedToArray3.default)(_label$split, 2),
      labelStart = _label$split2[0],
      labelEnd = _label$split2[1];

  var invalid = touched && !!error;
  return _react2.default.createElement(
    _carbonComponentsReact.DatePicker,
    (0, _extends3.default)({
      id: name,
      className: className,
      datePickerType: 'range'
      // eslint-disable-next-line
      , onChange: function (_onChange) {
        function onChange(_x) {
          return _onChange.apply(this, arguments);
        }

        onChange.toString = function () {
          return _onChange.toString();
        };

        return onChange;
      }(function (dates) {
        if (dates.length < 2) {
          // DatePicker can return an array of one while you're in the process
          // of selecting a range.
          return;
        }
        onChange(dates || null);
        // redux-form updates `touched` on blur.
        onBlur();
      })
    }, rest),
    _react2.default.createElement(_carbonComponentsReact.DatePickerInput, {
      onChange: doNothing,
      onClick: doNothing,
      labelText: labelStart,
      placeholder: placeholder,
      id: idStart,
      invalid: invalid,
      invalidText: error,
      pattern: null
    }),
    _react2.default.createElement(_carbonComponentsReact.DatePickerInput, {
      onChange: doNothing,
      onClick: doNothing,
      labelText: labelEnd,
      placeholder: placeholder,
      id: idEnd,
      invalid: invalid,
      pattern: null
    })
  );
};