'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.twelveHourTimeToMinutes = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _carbonComponentsReact = require('carbon-components-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var twelveHourTimeToMinutes = exports.twelveHourTimeToMinutes = function twelveHourTimeToMinutes(time) {
  var regex = /([^:]*):([^:]*)/;
  var match = regex.exec(time.timeString);

  var hours = parseInt(match[1]) % 12;

  if (time.dayPeriod === 'PM') {
    hours += 12;
  }

  return hours * 60 + parseInt(match[2]);
};

var TimePickerInput = function (_React$Component) {
  (0, _inherits3.default)(TimePickerInput, _React$Component);

  function TimePickerInput() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TimePickerInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TimePickerInput.__proto__ || (0, _getPrototypeOf2.default)(TimePickerInput)).call.apply(_ref, [this].concat(args))), _this), _this.handleTimeStringChange = function (event) {
      if (!(event.target instanceof HTMLInputElement)) {
        return;
      }

      _this.props.input.onChange((0, _extends3.default)({}, _this.props.input.value, {
        timeString: event.target.value
      }));
    }, _this.handleTimeStringBlur = function (event) {
      if (!(event.target instanceof HTMLInputElement)) {
        return;
      }

      _this.props.input.onBlur((0, _extends3.default)({}, _this.props.input.value, {
        timeString: event.target.value
      }));
    }, _this.handleDayPeriodChange = function (event) {
      if (!(event.target instanceof HTMLSelectElement)) {
        return;
      }

      var dayPeriod = event.target.value;

      _this.props.input.onChange((0, _extends3.default)({}, _this.props.input.value, {
        dayPeriod: dayPeriod
      }));
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TimePickerInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          input = _props.input,
          label = _props.label,
          _props$meta = _props.meta,
          touched = _props$meta.touched,
          error = _props$meta.error,
          className = _props.className,
          rest = (0, _objectWithoutProperties3.default)(_props, ['input', 'label', 'meta', 'className']);


      return _react2.default.createElement(
        _carbonComponentsReact.TimePicker,
        (0, _extends3.default)({}, input, {
          value: input.value.timeString,
          onChange: this.handleTimeStringChange,
          onBlur: this.handleTimeStringBlur // redux-form uses onBlur to update the value
          , id: input.name,
          labelText: label,
          invalid: touched && !!error,
          invalidText: error,
          className: className
        }, rest),
        _react2.default.createElement(
          _carbonComponentsReact.TimePickerSelect,
          {
            id: input.name + '-select',
            labelText: 'Choose AM or PM',
            value: input.value.dayPeriod,
            onChange: this.handleDayPeriodChange
          },
          _react2.default.createElement(_carbonComponentsReact.SelectItem, { value: 'AM', text: 'AM' }),
          _react2.default.createElement(_carbonComponentsReact.SelectItem, { value: 'PM', text: 'PM' })
        )
      );
    }
  }]);
  return TimePickerInput;
}(_react2.default.Component);

exports.default = TimePickerInput;