'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.trim = exports.timeZoneName = exports.hashShortifier = exports.addressShortifier = exports.thousandsDelimiter = exports.etherscanToken = exports.etherscanTx = exports.etherscanAddress = exports.setHelpersNetwork = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var network = '';

var setHelpersNetwork = exports.setHelpersNetwork = function setHelpersNetwork(name) {
  if (!name) {
    return;
  }
  network = name.split(' ')[0].toLowerCase();
  if (network === 'mainnet') {
    network = '';
  }
};

var etherscan = function etherscan(type, value, label) {
  return _react2.default.createElement(
    'a',
    {
      href: 'https://' + (network ? network + '.' : '') + 'etherscan.io/' + type + '/' + value,
      target: '_blank',
      rel: 'noopener noreferrer'
    },
    label
  );
};

var etherscanAddress = exports.etherscanAddress = function etherscanAddress(address, label) {
  return etherscan('address', address, label || address);
};

var etherscanTx = exports.etherscanTx = function etherscanTx(hash) {
  return etherscan('tx', hash, hashShortifier(hash));
};

var etherscanToken = exports.etherscanToken = function etherscanToken(address, label) {
  return etherscan('token', address, label || address);
};

var thousandsDelimiter = exports.thousandsDelimiter = function thousandsDelimiter(v) {
  var _v$toString$split = v.toString(10).split('.'),
      _v$toString$split2 = (0, _slicedToArray3.default)(_v$toString$split, 2),
      i = _v$toString$split2[0],
      f = _v$toString$split2[1];

  return i.replace(/\B(?=(\d{3})+(?!\d))/g, ',') + (f ? '.' + f : '');
};

var addressShortifier = exports.addressShortifier = function addressShortifier(address) {
  return address.substring(0, 7) + '...' + address.slice(-7);
};

var hashShortifier = exports.hashShortifier = function hashShortifier(hash) {
  return hash.substring(0, 10) + '...' + hash.slice(-4);
};

var timeZoneName = exports.timeZoneName = function timeZoneName() {
  var dateString = new Date().toLocaleDateString('en', { timeZoneName: 'long' });
  var comma = dateString.indexOf(', ');
  if (comma === -1) {
    return null;
  }

  return dateString.substring(comma + 2);
};

var trim = exports.trim = function trim(value) {
  return value && value.trim();
};