'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reduxForm = require('redux-form');

var _carbonComponentsReact = require('carbon-components-react');

var _actions = require('./actions');

var _EnterPINForm = require('./EnterPINForm');

var _EnterPINForm2 = _interopRequireDefault(_EnterPINForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    email: state.pui.account.email,
    isEnterPINModalOpen: state.pui.account.isEnterPINModalOpen,
    isSuccess: state.pui.account.isEnterPINSuccess,
    isError: state.pui.account.isEnterPINError
  };
};

var mapDispatchToProps = {
  cancelConfirmEmail: _actions.cancelConfirmEmail,
  confirmEmail: _actions.confirmEmail,
  reset: _reduxForm.reset
};

var EnterPINModal = function (_Component) {
  (0, _inherits3.default)(EnterPINModal, _Component);

  function EnterPINModal() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, EnterPINModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = EnterPINModal.__proto__ || (0, _getPrototypeOf2.default)(EnterPINModal)).call.apply(_ref, [this].concat(args))), _this), _this.handleChange = function (value) {
      _this.props.confirmEmail(value);
    }, _this.handleClose = function () {
      _this.props.cancelConfirmEmail();
      _this.props.reset(_EnterPINForm.formName);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(EnterPINModal, [{
    key: 'render',


    // eslint-disable-next-line
    value: function render() {
      var _props = this.props,
          isSuccess = _props.isSuccess,
          isError = _props.isError;

      return _react2.default.createElement(
        _carbonComponentsReact.Modal,
        {
          className: 'pui-tx-modal pui-pin-modal' + (isSuccess ? ' pui-tx-success' : '') + (isError ? ' pui-tx-failed' : ''),
          open: this.props.isEnterPINModalOpen,
          onRequestClose: this.handleClose,
          passiveModal: true,
          modalHeading: 'Enter the PIN from the Activation Email',
          modalLabel: isSuccess ? 'PIN is Correct' : isError ? 'Invalid PIN, Please Try Again' : 'Action Required'
        },
        _react2.default.createElement('div', { className: 'pui-tx-animation' }),
        _react2.default.createElement(_EnterPINForm2.default, { onChange: this.handleChange })
      );
    }
  }]);
  return EnterPINModal;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(EnterPINModal);