'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formName = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _carbonComponentsReact = require('carbon-components-react');

var _reduxForm = require('redux-form');

var _ = require('../../');

var _validate = require('../../validate');

var _helpers = require('../../helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formName = exports.formName = 'signup';

var maxLength100 = (0, _validate.maxLength)(100);

var SignUpForm = function (_Component) {
  (0, _inherits3.default)(SignUpForm, _Component);

  function SignUpForm() {
    (0, _classCallCheck3.default)(this, SignUpForm);
    return (0, _possibleConstructorReturn3.default)(this, (SignUpForm.__proto__ || (0, _getPrototypeOf2.default)(SignUpForm)).apply(this, arguments));
  }

  (0, _createClass3.default)(SignUpForm, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _carbonComponentsReact.Form,
        { onSubmit: this.props.handleSubmit },
        _react2.default.createElement(_reduxForm.Field, {
          name: 'name',
          component: _.TextInput,
          label: 'Name',
          placeholder: 'Enter your name',
          validate: [_validate.required, maxLength100]
        }),
        _react2.default.createElement(_reduxForm.Field, {
          name: 'email',
          component: _.TextInput,
          label: 'Email',
          placeholder: 'Enter your email address',
          validate: [_validate.required, _validate.email],
          normalize: _helpers.trim
        }),
        _react2.default.createElement(
          'div',
          { className: 'pui-sign-up-checkboxes' },
          _react2.default.createElement(_reduxForm.Field, {
            name: 'acceptPrivacy',
            component: _.CheckboxInput,
            className: 'pui-checkbox-small-text',
            label: _react2.default.createElement(
              _react.Fragment,
              null,
              _react2.default.createElement(
                'p',
                null,
                'I accept that Polymath may contact me via email to send me updates on my token issuance process.'
              ),
              _react2.default.createElement(
                'p',
                null,
                'For more details, please consult our ',
                _react2.default.createElement(
                  _carbonComponentsReact.Link,
                  { target: '_blank', href: 'https://polymath.network/privacypolicy.html' },
                  'Privacy Policy'
                )
              )
            )
          }),
          _react2.default.createElement(_reduxForm.Field, {
            name: 'acceptTerms',
            component: _.CheckboxInput,
            className: 'pui-checkbox-small-text',
            label: _react2.default.createElement(
              'p',
              null,
              'I accept the\xA0',
              _react2.default.createElement(
                _carbonComponentsReact.Link,
                { target: '_blank', href: 'https://polymath.network/termsofservice.html' },
                'Terms of Service'
              )
            )
          })
        ),
        _react2.default.createElement(
          _carbonComponentsReact.Button,
          { type: 'submit', disabled: !this.props.enableSubmit },
          'CREATE ACCOUNT'
        )
      );
    }
  }]);
  return SignUpForm;
}(_react.Component);

exports.default = (0, _reduxForm.reduxForm)({
  form: formName
})(SignUpForm);