'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.faucet = exports.providersApply = exports.email = exports.confirmEmail = exports.requestConfirmEmail = exports.signUp = exports.signIn = exports.fetchBalance = exports.setBalance = exports.BALANCE = exports.emailConfirmed = exports.EMAIL_CONFIRMED = exports.cancelConfirmEmail = exports.CANCEL_CONFIRM_EMAIL = exports.ENTER_PIN_ERROR = exports.ENTER_PIN_SUCCESS = exports.ENTER_PIN_DEFAULT = exports.REQUEST_CONFIRM_EMAIL = exports.signedUp = exports.SIGNED_UP = exports.signedIn = exports.SIGNED_IN = exports.signInCancel = exports.SIGN_IN_CANCEL = exports.signInStart = exports.SIGN_IN_START = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _ethSigUtil = require('eth-sig-util');

var _ethSigUtil2 = _interopRequireDefault(_ethSigUtil);

var _polymathjs = require('polymathjs');

var _Remark = require('../../components/Remark');

var _Remark2 = _interopRequireDefault(_Remark);

var _ = require('../..');

var _SignUpForm = require('./SignUpForm');

var _offchain = require('../../offchain');

var offchain = _interopRequireWildcard(_offchain);

var _actions = require('../tx/actions');

var _actions2 = require('../modal/actions');

var _helpers = require('../../helpers');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SIGN_IN_START = exports.SIGN_IN_START = 'polymath-ui/account/SIGN_IN_START';

var signInStart = exports.signInStart = function signInStart() {
  return { type: SIGN_IN_START };
};

var SIGN_IN_CANCEL = exports.SIGN_IN_CANCEL = 'polymath-ui/account/SIGN_IN_CANCEL';
var signInCancel = exports.signInCancel = function signInCancel() {
  return { type: SIGN_IN_CANCEL };
};

var SIGNED_IN = exports.SIGNED_IN = 'polymath-ui/account/SIGNED_IN';
var signedIn = exports.signedIn = function signedIn() {
  return { type: SIGNED_IN };
};

var SIGNED_UP = exports.SIGNED_UP = 'polymath-ui/account/SIGNED_UP';
var signedUp = exports.signedUp = function signedUp(name, email) {
  var isEmailConfirmed = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  return { type: SIGNED_UP, name: name, email: email, isEmailConfirmed: isEmailConfirmed };
};

var REQUEST_CONFIRM_EMAIL = exports.REQUEST_CONFIRM_EMAIL = 'polymath-ui/account/REQUEST_CONFIRM_EMAIL';
var ENTER_PIN_DEFAULT = exports.ENTER_PIN_DEFAULT = 'polymath-ui/account/ENTER_PIN_DEFAULT';
var ENTER_PIN_SUCCESS = exports.ENTER_PIN_SUCCESS = 'polymath-ui/account/ENTER_PIN_SUCCESS';
var ENTER_PIN_ERROR = exports.ENTER_PIN_ERROR = 'polymath-ui/account/ENTER_PIN_ERROR';
var CANCEL_CONFIRM_EMAIL = exports.CANCEL_CONFIRM_EMAIL = 'polymath-ui/account/CANCEL_CONFIRM_EMAIL';
var cancelConfirmEmail = exports.cancelConfirmEmail = function cancelConfirmEmail() {
  return { type: CANCEL_CONFIRM_EMAIL };
};

var EMAIL_CONFIRMED = exports.EMAIL_CONFIRMED = 'polymath-ui/account/EMAIL_CONFIRMED';
var emailConfirmed = exports.emailConfirmed = function emailConfirmed() {
  return { type: EMAIL_CONFIRMED };
};

var BALANCE = exports.BALANCE = 'polymath-ui/account/BALANCE';
var setBalance = exports.setBalance = function setBalance(balance) {
  return { type: BALANCE, balance: balance };
};

var fetchBalance = exports.fetchBalance = function fetchBalance() {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dispatch) {
      var balance;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _polymathjs.PolyToken.myBalance();

            case 2:
              balance = _context2.sent;
              _context2.next = 5;
              return _polymathjs.PolyToken.subscribeMyTransfers(function () {
                var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(toOrFrom, value, isFrom) {
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.t0 = dispatch;
                          _context.t1 = setBalance;
                          _context.next = 4;
                          return _polymathjs.PolyToken.myBalance();

                        case 4:
                          _context.t2 = _context.sent;
                          _context.t3 = (0, _context.t1)(_context.t2);
                          (0, _context.t0)(_context.t3);

                          dispatch((0, _.notify)((isFrom ? 'Sent' : 'Received') + ' ' + (0, _helpers.thousandsDelimiter)(value) + ' POLY'), true);

                        case 8:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined);
                }));

                return function (_x3, _x4, _x5) {
                  return _ref2.apply(this, arguments);
                };
              }());

            case 5:
              dispatch(setBalance(balance));

            case 6:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

var signIn = exports.signIn = function signIn() {
  return function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(dispatch, getState) {
      var _getState$network, web3, account, authCode, authName, _ref4, _ref5, sig, user;

      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!getState().pui.account.isSignedIn) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt('return');

            case 2:

              dispatch((0, _.fetching)());
              dispatch(signInStart());

              _getState$network = getState().network, web3 = _getState$network.web3, account = _getState$network.account;


              if (global.FS) {
                global.FS.identify(account, {
                  ethAddress: account
                });
              }

              authCode = void 0, authName = void 0;
              _context3.prev = 7;
              _context3.next = 10;
              return _promise2.default.all([offchain.getAuthCode(account), offchain.getAuthName(), dispatch(fetchBalance())]);

            case 10:
              _ref4 = _context3.sent;
              _ref5 = (0, _slicedToArray3.default)(_ref4, 2);
              authCode = _ref5[0];
              authName = _ref5[1];
              _context3.next = 20;
              break;

            case 16:
              _context3.prev = 16;
              _context3.t0 = _context3['catch'](7);

              dispatch((0, _.fetchingFailed)(_context3.t0));
              return _context3.abrupt('return');

            case 20:

              dispatch((0, _.fetched)());

              sig = void 0;
              _context3.prev = 22;
              _context3.next = 25;
              return signData(web3, authCode, [{ type: 'string', name: authName, value: authCode }], account);

            case 25:
              sig = _context3.sent;
              _context3.next = 32;
              break;

            case 28:
              _context3.prev = 28;
              _context3.t1 = _context3['catch'](22);

              dispatch(signInCancel());
              return _context3.abrupt('return');

            case 32:

              dispatch((0, _.fetching)());
              _context3.prev = 33;
              _context3.next = 36;
              return offchain.auth(authCode, sig, account);

            case 36:
              user = _context3.sent;


              if (global.FS) {
                global.FS.identify(account, (0, _extends3.default)({
                  ethAddress: account
                }, user || {}));
              }

              dispatch(signedIn());

              if (user) {
                dispatch(signedUp(user.name, user.email, true));
              }

              dispatch((0, _.fetched)());
              _context3.next = 46;
              break;

            case 43:
              _context3.prev = 43;
              _context3.t2 = _context3['catch'](33);

              dispatch((0, _.fetchingFailed)(_context3.t2));

            case 46:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined, [[7, 16], [22, 28], [33, 43]]);
    }));

    return function (_x6, _x7) {
      return _ref3.apply(this, arguments);
    };
  }();
};

var signData = function () {
  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(web3, normal, typed, address) {
    var result, recovered;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (web3.currentProvider.sendAsync) {
              _context4.next = 2;
              break;
            }

            return _context4.abrupt('return', web3.eth.sign(normal, address));

          case 2:
            _context4.next = 4;
            return new _promise2.default(function (resolve, reject) {
              web3.currentProvider.sendAsync({
                method: 'eth_signTypedData',
                params: [typed, address],
                from: address
              }, function (err, result) {
                return err ? reject(err) : resolve(result);
              });
            });

          case 4:
            result = _context4.sent;

            if (!result.error) {
              _context4.next = 7;
              break;
            }

            throw result.error;

          case 7:
            recovered = _ethSigUtil2.default.recoverTypedSignature({
              data: typed,
              sig: result.result
            });

            if (!(recovered.toLowerCase() !== address.toLowerCase())) {
              _context4.next = 10;
              break;
            }

            throw new Error('Failed to verify signer, got: ' + result);

          case 10:
            return _context4.abrupt('return', result.result);

          case 11:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function signData(_x8, _x9, _x10, _x11) {
    return _ref6.apply(this, arguments);
  };
}();

var signUp = exports.signUp = function signUp() {
  return function () {
    var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(dispatch, getState) {
      var _getState$form$signUp, name, email;

      return _regenerator2.default.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _getState$form$signUp = getState().form[_SignUpForm.formName].values, name = _getState$form$signUp.name, email = _getState$form$signUp.email;

              dispatch(signedUp(name, email, false));
              dispatch((0, _.fetched)());
              dispatch((0, _.notify)('You Were Successfully Signed Up', true));

            case 4:
            case 'end':
              return _context5.stop();
          }
        }
      }, _callee5, undefined);
    }));

    return function (_x12, _x13) {
      return _ref7.apply(this, arguments);
    };
  }();
};

var requestConfirmEmail = exports.requestConfirmEmail = function requestConfirmEmail(email) {
  return function () {
    var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(dispatch, getState) {
      var name;
      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              name = getState().pui.account.name;

              if (!email) {
                // eslint-disable-next-line no-param-reassign
                email = getState().pui.account.email;
              } else {
                // $FlowFixMe
                dispatch(signedUp(name, email, false));
              }
              dispatch((0, _.fetching)());
              _context6.prev = 3;
              _context6.next = 6;
              return offchain.newEmail(email, name);

            case 6:
              dispatch({ type: REQUEST_CONFIRM_EMAIL });
              dispatch((0, _.fetched)());
              _context6.next = 13;
              break;

            case 10:
              _context6.prev = 10;
              _context6.t0 = _context6['catch'](3);

              dispatch((0, _.fetchingFailed)(_context6.t0));

            case 13:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, undefined, [[3, 10]]);
    }));

    return function (_x14, _x15) {
      return _ref8.apply(this, arguments);
    };
  }();
};

var confirmEmail = exports.confirmEmail = function confirmEmail(pin) {
  return function () {
    var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(dispatch, getState) {
      var _getState$pui$account, _email, _name, account;

      return _regenerator2.default.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!(typeof pin !== 'string')) {
                _context7.next = 2;
                break;
              }

              return _context7.abrupt('return');

            case 2:
              if (pin) {
                _context7.next = 5;
                break;
              }

              dispatch({ type: ENTER_PIN_DEFAULT });
              return _context7.abrupt('return');

            case 5:
              _context7.prev = 5;
              _context7.next = 8;
              return offchain.confirmEmail(pin);

            case 8:
              // TODO @bshevchenko: show success screen
              if (global.FS) {
                _getState$pui$account = getState().pui.account, _email = _getState$pui$account.email, _name = _getState$pui$account.name;
                account = getState().network.account;

                global.FS.identify(account, {
                  ethAddress: account,
                  email: _email,
                  name: _name
                });
              }
              dispatch({ type: ENTER_PIN_SUCCESS });
              _context7.next = 15;
              break;

            case 12:
              _context7.prev = 12;
              _context7.t0 = _context7['catch'](5);

              dispatch({ type: ENTER_PIN_ERROR });

            case 15:
            case 'end':
              return _context7.stop();
          }
        }
      }, _callee7, undefined, [[5, 12]]);
    }));

    return function (_x16, _x17) {
      return _ref9.apply(this, arguments);
    };
  }();
};

// eslint-disable-next-line global-require, import/no-unresolved, $FlowFixMe
var polymathJS = require('polymathjs/package.json');

// eslint-disable-next-line max-len
var email = exports.email = function email(txHash, subject, body) {
  return function () {
    var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(dispatch, getState) {
      return _regenerator2.default.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return offchain.email(txHash, subject, body, polymathJS.dependencies['polymath-core'], getState().network.id);

            case 2:
            case 'end':
              return _context8.stop();
          }
        }
      }, _callee8, undefined);
    }));

    return function (_x18, _x19) {
      return _ref10.apply(this, arguments);
    };
  }();
};

var providersApply = exports.providersApply = function providersApply(data) {
  return function () {
    var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(dispatch, getState) {
      return _regenerator2.default.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.next = 2;
              return offchain.providersApply(data, polymathJS.dependencies['polymath-core'], getState().network.id);

            case 2:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, undefined);
    }));

    return function (_x20, _x21) {
      return _ref11.apply(this, arguments);
    };
  }();
};

var faucet = exports.faucet = function faucet(message) {
  return function () {
    var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(dispatch, getState) {
      var intro, title, headerLabel, amount, buttonLabel;
      return _regenerator2.default.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              intro = _react2.default.createElement(
                'p',
                null,
                message,
                '\xA0 Please make sure that your wallet has a sufficient balance in POLY to complete this operation.'
              );
              title = 'Insufficient POLY Balance';
              headerLabel = 'Transaction Impossible';

              if (!(Number(getState().network.id) === 1)) {
                _context11.next = 6;
                break;
              }

              dispatch((0, _actions2.confirm)(_react2.default.createElement(
                'div',
                null,
                intro,
                _react2.default.createElement(
                  'p',
                  null,
                  'If you need to obtain POLY tokens, you can visit\xA0',
                  _react2.default.createElement(
                    'a',
                    { target: '_blank', rel: 'noopener noreferrer', href: 'https://shapeshift.io' },
                    'this'
                  ),
                  ' or obtain more information\xA0',
                  _react2.default.createElement(
                    'a',
                    {
                      target: '_blank',
                      rel: 'noopener noreferrer',
                      href: 'https://etherscan.io/token/0x9992ec3cf6a55b00978cddf2b27bc6882d88d1ec#tokenExchange'
                    },
                    'here'
                  ),
                  '.'
                )
              ), function () {}, title, 'Understood', '', headerLabel));
              return _context11.abrupt('return');

            case 6:
              amount = 25000;
              buttonLabel = 'REQUEST ' + amount / 1000 + 'K POLY';

              dispatch((0, _actions2.confirm)(_react2.default.createElement(
                'div',
                null,
                intro,
                _react2.default.createElement(
                  'p',
                  null,
                  'You are currently connected to the ',
                  _react2.default.createElement(
                    'span',
                    { style: { fontWeight: 'bold' } },
                    'Kovan Test Network'
                  ),
                  '.'
                ),
                _react2.default.createElement(
                  'p',
                  null,
                  'As such, you can click on the \xAB',
                  buttonLabel,
                  '\xBB button below to receive ',
                  (0, _helpers.thousandsDelimiter)(amount),
                  ' test POLY in your wallet.'
                ),
                _react2.default.createElement('br', null),
                _react2.default.createElement(
                  _Remark2.default,
                  { title: 'Note' },
                  'This option is not available on the Mainnet.'
                )
              ), function () {
                var account = getState().network.account;

                dispatch((0, _actions.tx)(['Receiving POLY From Faucet'], (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10() {
                  return _regenerator2.default.wrap(function _callee10$(_context10) {
                    while (1) {
                      switch (_context10.prev = _context10.next) {
                        case 0:
                          _context10.next = 2;
                          return _polymathjs.PolyToken.getTokens(amount, account);

                        case 2:
                        case 'end':
                          return _context10.stop();
                      }
                    }
                  }, _callee10, undefined);
                })), 'You have successfully received ' + (0, _helpers.thousandsDelimiter)(amount) + ' POLY', undefined, undefined, undefined, true));
              }, title, buttonLabel, '', headerLabel));

            case 9:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, undefined);
    }));

    return function (_x22, _x23) {
      return _ref12.apply(this, arguments);
    };
  }();
};