'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

var _actions = require('./actions');

var a = _interopRequireWildcard(_actions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultState = {
  isSignedUp: null,
  isSignedIn: false,
  isSignInCancelled: false,
  name: null,
  email: null,
  isEmailConfirmed: null,
  isEnterPINModalOpen: false,
  isEnterPINSuccess: false,
  isEnterPINError: false,
  balance: null
  // eslint-disable-next-line complexity
};
exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case a.SIGN_IN_START:
      return (0, _extends3.default)({}, state, {
        isSignInCancelled: false
      });
    case a.SIGN_IN_CANCEL:
      return (0, _extends3.default)({}, state, {
        isSignInCancelled: true
      });
    case a.SIGNED_IN:
      return (0, _extends3.default)({}, state, {
        isSignedIn: true
      });
    case a.SIGNED_UP:
      return (0, _extends3.default)({}, state, {
        isSignedUp: true,
        name: action.name,
        email: action.email,
        isEmailConfirmed: action.isEmailConfirmed
      });
    case a.REQUEST_CONFIRM_EMAIL:
      return (0, _extends3.default)({}, state, {
        isEnterPINModalOpen: true
      });
    case a.CANCEL_CONFIRM_EMAIL:
      return (0, _extends3.default)({}, state, {
        isEnterPINModalOpen: false,
        isEnterPINSuccess: false,
        isEnterPINError: false
      });
    case a.ENTER_PIN_SUCCESS:
      return (0, _extends3.default)({}, state, {
        isEnterPINError: false,
        isEnterPINSuccess: true,
        isEnterPINModalOpen: false
      });
    case a.ENTER_PIN_ERROR:
      return (0, _extends3.default)({}, state, {
        isEnterPINError: true
      });
    case a.ENTER_PIN_DEFAULT:
      return (0, _extends3.default)({}, state, {
        isEnterPINError: false,
        isEnterPINSuccess: false
      });
    case a.EMAIL_CONFIRMED:
      return (0, _extends3.default)({}, state, {
        isEmailConfirmed: true
      });
    case a.BALANCE:
      return (0, _extends3.default)({}, state, {
        balance: action.balance
      });
    default:
      return state;
  }
};