'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _carbonComponentsReact = require('carbon-components-react');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTransitionGroup = require('react-transition-group');

var _reactRedux = require('react-redux');

var _style = require('../../style.css');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var duration = 6000;

// this line would be 'style.scss' if we were to bundle with Webpack.
// noinspection JSFileReferences $FlowFixMe

/* eslint-disable import/no-unresolved */

var mapStateToProps = function mapStateToProps(state) {
  return {
    notify: state.pui.toaster.notify
  };
};

var Toaster = function (_Component) {
  (0, _inherits3.default)(Toaster, _Component);

  function Toaster() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Toaster);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Toaster.__proto__ || (0, _getPrototypeOf2.default)(Toaster)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      toasts: []
    }, _this.getToastIndexByKey = function (state, key) {
      return state.toasts.map(function (toast) {
        return toast.key;
      }).indexOf(key);
    }, _this.startHidingKey = function (key) {
      _this.setState(function (previousState) {
        var index = _this.getToastIndexByKey(previousState, key);
        if (index === -1 || previousState.toasts[index].hiding) {
          return;
        }

        // noinspection JSUnresolvedVariable
        setTimeout(function () {
          _this.removeKey(key);
        }, _style2.default.toastAnimationDuration);

        return (0, _extends3.default)({}, previousState, {
          toasts: (0, _assign2.default)([].concat((0, _toConsumableArray3.default)(previousState.toasts)), (0, _defineProperty3.default)({}, index, (0, _extends3.default)({}, previousState.toasts[index], {
            hiding: true
          })))
        });
      });
    }, _this.removeKey = function (key) {
      _this.setState(function (previousState) {
        var index = _this.getToastIndexByKey(previousState, key);
        if (index === -1) {
          return;
        }

        return (0, _extends3.default)({}, previousState, {
          toasts: [].concat((0, _toConsumableArray3.default)(previousState.toasts.slice(0, index)), (0, _toConsumableArray3.default)(previousState.toasts.slice(index + 1)))
        });
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Toaster, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var notify = nextProps.notify;

      if (notify && notify !== this.props.notify) {
        this.show({
          title: notify.title || '',
          subtitle: notify.subtitle || '',
          caption: notify.caption || null,
          kind: notify.isSuccess ? 'success' : 'error'
        }, notify.isPinned || false);
      }
    }
  }, {
    key: 'clear',
    value: function clear() {
      this.setState({ toasts: [] });
    }
  }, {
    key: 'show',
    value: function show(toast) {
      var _this2 = this;

      var isPinned = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      this.setState(function (previousState) {
        var toasts = previousState.toasts;
        var newKey = toasts.reduce(function (max, toast) {
          return Math.max(max, toast.key);
        }, toasts[0] ? toasts[0].key : 0) + 1;

        if (!isPinned) {
          setTimeout(function () {
            _this2.startHidingKey(newKey);
          }, duration);
        }

        return (0, _extends3.default)({}, previousState, {
          toasts: [{
            key: newKey,
            data: toast,
            hiding: false
          }].concat((0, _toConsumableArray3.default)(toasts))
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var toastElements = this.state.toasts.map(function (_ref2) {
        var key = _ref2.key,
            hiding = _ref2.hiding,
            data = _ref2.data;
        return _react2.default.createElement(
          _reactTransitionGroup.Transition,
          {
            key: key,
            'in': !hiding,
            appear: true,
            timeout: 0
          },
          function (status) {
            return _react2.default.createElement(_carbonComponentsReact.ToastNotification, (0, _extends3.default)({}, data, {
              // eslint-disable-next-line
              onCloseButtonClick: function onCloseButtonClick() {
                return _this3.removeKey(key);
              },
              className: 'pui-toast pui-toast-' + status
            }));
          }
        );
      });

      return _react2.default.createElement(
        'div',
        { className: 'pui-toaster-container' },
        _react2.default.createElement(
          'div',
          { className: 'pui-toaster' },
          toastElements
        )
      );
    }
  }]);
  return Toaster;
}(_react.Component);

Toaster.defaultProps = {
  notify: null
};
exports.default = (0, _reactRedux.connect)(mapStateToProps)(Toaster);