'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _carbonComponentsReact = require('carbon-components-react');

var _actions = require('./actions');

var _helpers = require('../../helpers');

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  return state.pui.tx;
};

var mapDispatchToProps = {
  txContinue: _actions.txContinue
};

var TxModal = function (_Component) {
  (0, _inherits3.default)(TxModal, _Component);

  function TxModal() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, TxModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = TxModal.__proto__ || (0, _getPrototypeOf2.default)(TxModal)).call.apply(_ref, [this].concat(args))), _this), _this.handleContinue = function () {
      _this.props.txContinue();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(TxModal, [{
    key: 'render',


    // eslint-disable-next-line
    value: function render() {
      var current = Number(this.props.current);
      var _props = this.props,
          total = _props.total,
          error = _props.error,
          isFinished = _props.isFinished,
          hashes = _props.hashes,
          titles = _props.titles,
          successTitle = _props.successTitle,
          headingOverride = _props.headingOverride;


      var modalHeading = void 0;
      if (headingOverride) {
        modalHeading = this.props.headingOverride;
      } else {
        modalHeading = error ? error.message : isFinished ? successTitle : 'Sign Transaction' + (Number(total) > 1 ? 's' : '');
      }

      return _react2.default.createElement(
        _carbonComponentsReact.Modal,
        {
          className: 'pui-tx-modal' + (isFinished ? ' pui-tx-success' : '') + (error ? ' pui-tx-failed' : ''),
          open: !!total,
          passiveModal: true,
          modalHeading: modalHeading,
          modalLabel: 'Transaction ' + (isFinished ? 'Completed' : '') + (error ? 'Failed' : '') + (!isFinished && !error ? 'Processing' : '')
        },
        _react2.default.createElement('div', { className: 'pui-tx-animation' }),
        titles.map(function (title, i) {
          return _react2.default.createElement(
            'div',
            { key: title, className: 'pui-tx-row' + (i > current ? ' pui-tx-next' : '') },
            _react2.default.createElement(
              'div',
              { className: 'pui-tx-icon' },
              current === i ? error ? _react2.default.createElement(_carbonComponentsReact.Icon, { name: 'close', fill: '#E71D32', width: '32', height: '32' }) : _react2.default.createElement(_carbonComponentsReact.Loading, { withOverlay: false }) : i < current ? _react2.default.createElement(_carbonComponentsReact.Icon, { name: 'checkmark', fill: '#00AA5E', width: '32', height: '24' }) : ''
            ),
            _react2.default.createElement(
              'div',
              { className: 'pui-tx-info' },
              _react2.default.createElement(
                'h3',
                { className: 'pui-h3' },
                title
              ),
              _react2.default.createElement(
                'div',
                { className: 'pui-tx-details' },
                'Transaction details on Etherscan:\xA0',
                hashes[i] ? (0, _helpers.etherscanTx)(hashes[i]) : '...'
              )
            )
          );
        }),
        isFinished && !this.props.isNoEmail ? _react2.default.createElement(
          'div',
          { className: 'pui-tx-row pui-tx-email' },
          _react2.default.createElement(
            'div',
            { className: 'pui-tx-icon' },
            _.icoPaperPlane
          ),
          _react2.default.createElement(
            'div',
            { className: 'pui-tx-details' },
            _react2.default.createElement(
              'h4',
              { className: 'pui-h4' },
              'We just sent you an email with the transaction details for your records. Check your inbox.'
            )
          )
        ) : '',
        _react2.default.createElement(
          'p',
          { className: 'pui-tx-continue' },
          isFinished || error ? _react2.default.createElement(
            _carbonComponentsReact.Button,
            { onClick: this.handleContinue },
            this.props.continueLabel || 'Continue'
          ) : ''
        )
      );
    }
  }]);
  return TxModal;
}(_react.Component);

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(TxModal);