'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _reduxMockStore = require('redux-mock-store');

var _reduxMockStore2 = _interopRequireDefault(_reduxMockStore);

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _actions = require('../actions');

var actions = _interopRequireWildcard(_actions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mockStore = (0, _reduxMockStore2.default)([_reduxThunk2.default]);

var mockTxData = {
  titles: 'Some transaction title',
  successTitle: 'Success title',
  code: function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    function code() {
      return _ref.apply(this, arguments);
    }

    return code;
  }(),
  continueCode: function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    function continueCode() {
      return _ref2.apply(this, arguments);
    }

    return continueCode;
  }(),
  continueRoute: 'continue-route',
  continueLabel: 'continue-label',
  isNoEmail: true,
  headingOverride: true
};
var txArgs = [mockTxData.titles, mockTxData.code, mockTxData.successTitle, mockTxData.continueCode, mockTxData.continueRoute, mockTxData.continueLabel, mockTxData.isNoEmail, mockTxData.headingOverride];

var store = void 0;

afterEach(function () {
  store = mockStore();
});

describe('Actions: tx', function () {
  describe('tx', function () {
    test('it is a thunk', function () {
      var returnType = (0, _typeof3.default)(actions.tx.apply(actions, txArgs));
      expect(returnType).toEqual('function');
    });

    test('should dispatch START action', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
      var titles, successTitle, continueLabel, continueRoute, isNoEmail, headingOverride, continueCode, expectedStartAction, _store$getActions, _store$getActions2, dispatchedAction;

      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              titles = mockTxData.titles, successTitle = mockTxData.successTitle, continueLabel = mockTxData.continueLabel, continueRoute = mockTxData.continueRoute, isNoEmail = mockTxData.isNoEmail, headingOverride = mockTxData.headingOverride, continueCode = mockTxData.continueCode;
              // TODO: Remove when an action creator for START exists

              expectedStartAction = {
                type: actions.START,
                titles: [titles],
                successTitle: successTitle, continueLabel: continueLabel, continueRoute: continueRoute, isNoEmail: isNoEmail, headingOverride: headingOverride, continueCode: continueCode
              };
              _context3.next = 4;
              return store.dispatch(actions.tx.apply(actions, txArgs));

            case 4:
              _store$getActions = store.getActions(), _store$getActions2 = (0, _slicedToArray3.default)(_store$getActions, 1), dispatchedAction = _store$getActions2[0];

              expect(dispatchedAction).toEqual(expectedStartAction);

            case 6:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    })));
  });
});