'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.txContinue = exports.CONTINUE = exports.txEnd = exports.END = exports.txHash = exports.HASH = exports.tx = exports.FAILED = exports.START = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var START = exports.START = 'polymath-ui/tx/START';
var FAILED = exports.FAILED = 'polymath-ui/tx/FAILED';
var tx = exports.tx = function tx(titles, code, successTitle, continueCode, continueRoute, continueLabel, isNoEmail, headingOverride) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dispatch) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // eslint-disable-next-line
              titles = typeof titles === 'string' ? [titles] : titles;
              dispatch({
                type: START, titles: titles, successTitle: successTitle, continueRoute: continueRoute, continueLabel: continueLabel,
                continueCode: continueCode, isNoEmail: isNoEmail, headingOverride: headingOverride
              });
              _context.prev = 2;
              _context.next = 5;
              return code();

            case 5:
              _context.next = 11;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context['catch'](2);

              // eslint-disable-next-line
              console.error('Tx failed', _context.t0);
              dispatch({ type: FAILED, error: _context.t0 });

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined, [[2, 7]]);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
};

var HASH = exports.HASH = 'polymath-ui/tx/HASH';
var txHash = exports.txHash = function txHash(hash) {
  return { type: HASH, hash: hash };
};

var END = exports.END = 'polymath-ui/tx/END';
var txEnd = exports.txEnd = function txEnd(receipt) {
  return { type: END, receipt: receipt };
};

var CONTINUE = exports.CONTINUE = 'polymath-ui/tx/CONTINUE';
var txContinue = exports.txContinue = function txContinue() {
  return function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(dispatch, getState) {
      var _getState$pui$tx, error, continueRoute, continueCode;

      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _getState$pui$tx = getState().pui.tx, error = _getState$pui$tx.error, continueRoute = _getState$pui$tx.continueRoute, continueCode = _getState$pui$tx.continueCode;

              dispatch({ type: CONTINUE });

              if (error) {
                _context2.next = 7;
                break;
              }

              if (!continueCode) {
                _context2.next = 6;
                break;
              }

              _context2.next = 6;
              return continueCode();

            case 6:
              if (continueRoute) {
                // $FlowFixMe
                getState().pui.common.history.push(continueRoute);
              }

            case 7:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }();
};