'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _actions = require('./actions');

var a = _interopRequireWildcard(_actions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultState = {
  titles: [],
  successTitle: null,
  continueCode: null,
  continueRoute: null,
  continueLabel: null,
  isNoEmail: false,
  hashes: [],
  receipts: [],
  total: null,
  current: null,
  isFinished: null,
  error: null,
  headingOverride: null
};

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments[1];

  switch (action.type) {
    case a.START:
      return (0, _extends3.default)({}, defaultState, action, {
        current: 0,
        total: action.titles.length
      });
    case a.HASH:
      return (0, _extends3.default)({}, state, {
        hashes: state.hashes.concat(action.hash)
      });
    case a.END:
      var _receipts = state.receipts.concat(action.receipt);
      var _current = _receipts.length;
      var _isFinished = false; // $FlowFixMe
      if (_current === state.total) {
        _isFinished = true;
      }
      return (0, _extends3.default)({}, state, {
        current: _receipts.length,
        receipts: _receipts,
        isFinished: _isFinished
      });
    case a.FAILED:
      return (0, _extends3.default)({}, state, {
        error: action.error
      });
    case a.CONTINUE:
      return (0, _extends3.default)({}, state, {
        total: null
      });
    default:
      return state;
  }
};