'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notice = exports.providersApply = exports.email = exports.confirmEmail = exports.newEmail = exports.auth = exports.getAuthCode = exports.getAuthName = exports.post = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var code = void 0;
var sig = void 0;
var address = void 0;
var instance = _axios2.default.create({
  baseURL: process.env.REACT_APP_POLYMATH_OFFCHAIN_ADDRESS || 'https://polymath-offchain.herokuapp.com/'
});

var res = function res(response) {
  if (response.status !== 200) {
    throw new Error(response.statusText);
  }
  if (response.data.status !== 'ok') {
    throw new Error(response.data.data);
  }
  return response.data.data;
};

var get = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(url) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.t0 = res;
            _context.next = 3;
            return instance.get(url);

          case 3:
            _context.t1 = _context.sent;
            return _context.abrupt('return', (0, _context.t0)(_context.t1));

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function get(_x) {
    return _ref.apply(this, arguments);
  };
}();

var post = exports.post = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(url, params) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.t0 = res;
            _context2.next = 3;
            return instance.post(url, params);

          case 3:
            _context2.t1 = _context2.sent;
            return _context2.abrupt('return', (0, _context2.t0)(_context2.t1));

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function post(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var getAuthName = exports.getAuthName = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt('return', get('/auth/name'));

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function getAuthName() {
    return _ref3.apply(this, arguments);
  };
}();

var getAuthCode = exports.getAuthCode = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(address) {
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt('return', get('/auth/' + address));

          case 1:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function getAuthCode(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

var auth = exports.auth = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(_code, _sig, _address) {
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            code = _code;
            sig = _sig;
            address = _address;
            return _context5.abrupt('return', post('/auth', { code: code, sig: sig, address: address }));

          case 4:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function auth(_x5, _x6, _x7) {
    return _ref5.apply(this, arguments);
  };
}();

var newEmail = exports.newEmail = function () {
  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(email, name) {
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            return _context6.abrupt('return', post('/email/new', { email: email, name: name, code: code, sig: sig, address: address }));

          case 1:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, undefined);
  }));

  return function newEmail(_x8, _x9) {
    return _ref6.apply(this, arguments);
  };
}();

var confirmEmail = exports.confirmEmail = function () {
  var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(pin) {
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            return _context7.abrupt('return', post('/email/confirm', { pin: pin }));

          case 1:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function confirmEmail(_x10) {
    return _ref7.apply(this, arguments);
  };
}();

var email = exports.email = function () {
  var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(txHash, subject, body, coreVer, network) {
    return _regenerator2.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            return _context8.abrupt('return', post('/email', {
              code: code,
              sig: sig,
              address: address,
              txHash: txHash,
              subject: subject,
              body: _server2.default.renderToStaticMarkup(body),
              coreVer: coreVer,
              network: network
            }));

          case 1:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function email(_x11, _x12, _x13, _x14, _x15) {
    return _ref8.apply(this, arguments);
  };
}();

var providersApply = exports.providersApply = function () {
  var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(data, coreVer, network) {
    return _regenerator2.default.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            return _context9.abrupt('return', post('/providers/apply', (0, _extends3.default)({}, data, {
              code: code,
              sig: sig,
              address: address,
              coreVer: coreVer,
              network: network
            })));

          case 1:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, undefined);
  }));

  return function providersApply(_x16, _x17, _x18) {
    return _ref9.apply(this, arguments);
  };
}();

var notice = exports.notice = function () {
  var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(scope) {
    return _regenerator2.default.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            return _context10.abrupt('return', get('/notice/' + scope));

          case 1:
          case 'end':
            return _context10.stop();
        }
      }
    }, _callee10, undefined);
  }));

  return function notice(_x19) {
    return _ref10.apply(this, arguments);
  };
}();